clear all
close all

% Define values for n:
nvec = 1:15;
% Get the total number of n's:
N = length(nvec);
% Prepare output for conditions and errors:
c = zeros(1,N);
err = zeros(1,N);
% Loop over n:
for k = 1:N
    % Get the next n:
    n = nvec(k);
    % Prepare right-hand side:
    e1 = zeros(n,1);
    e1(1) = 1;
    % Get the Hilbert-matrix:
    Hn = hilb(n);
    % Scale it:
    Hn2 = sqrt(2)*Hn;
    % Get the right-hand side:
    bn = e1;
    % Scale it:
    bn2 = sqrt(2)*bn;
    % Solve both linear systems:
    xn = Hn\bn;
    xn2 = Hn2\bn2;
    % Store relative error and condition numbers:
    err(k) = norm(xn - xn2,2)/norm(xn,2);
    c(k) = cond(Hn);
end
% Plot the results:
figure()
plot(nvec,err,'r')
xlabel('n')
ylabel('Relative Error')
figure()
plot(nvec,c)
xlabel('n')
ylabel('Condition Number')